import type { DocumentNode } from "graphql";
import { getSdk } from "./graphql";
import { WebhookSubscriber } from "./WebhookSubscriber";
export declare class ShopifyAdmin<T = unknown> {
    protected sdk: T;
    protected internalSdk: ReturnType<typeof getSdk>;
    protected activeCredentialIndex: number;
    protected credentials: ShopifyAdminCredential[];
    constructor(options: ClientOptions<T>);
    getCycledCredential(): ShopifyAdminCredential;
    get client(): T;
    get internalClient(): {
        pubSubWebhookSubscriptionCreate(variables: import("./graphql").Exact<{
            topic: import("./graphql").WebhookSubscriptionTopic;
            webhookSubscription: import("./graphql").PubSubWebhookSubscriptionInput;
        }>, options?: unknown): Promise<import("./graphql").PubSubWebhookSubscriptionCreateMutation>;
        webhookSubscriptionDelete(variables: import("./graphql").Exact<{
            id: string;
        }>, options?: unknown): Promise<import("./graphql").WebhookSubscriptionDeleteMutation>;
        webhookSubscriptions(variables?: import("./graphql").Exact<{
            [key: string]: never;
        }> | undefined, options?: unknown): Promise<import("./graphql").WebhookSubscriptionsQuery>;
    };
    get webhookSubscriber(): WebhookSubscriber;
}
export interface ShopifyAdminCredential {
    apiKey?: string;
    password: string;
}
declare type ClientOptions<T> = {
    shopName: string;
    apiVersion?: string;
    getSdk: (requester: Requester) => T;
    credentials: ShopifyAdminCredential | ShopifyAdminCredential[];
};
declare type Requester<C = {}> = <R, V>(doc: DocumentNode, vars?: V, options?: C) => Promise<R>;
export {};
