import { WebhookSubscriptionTopic } from "./graphql";
import { ShopifyAdmin } from "./ShopifyAdmin";
export declare class WebhookSubscriber {
    protected shopifyAdmin: ShopifyAdmin;
    constructor(shopifyAdmin: ShopifyAdmin);
    /**
     * Update Pub/Sub webhook subscriptions to match the given list of topics. Topics not present
     * in the list will have their subscriptions removed.
     */
    updatePubSubSubscriptions({ topics, pubSubTopic, pubSubProject, metafieldNamespaces, }: {
        pubSubTopic: string;
        pubSubProject: string;
        metafieldNamespaces?: string[];
        topics: WebhookSubscriptionTopic[];
    }): Promise<void>;
}
export { WebhookSubscriptionTopic };
